var Helpers = function(){
  var Random = require("random-js");
  this._crypto = require('crypto');
  this._random = new Random(Random.engines.mt19937().autoSeed());
}

Helpers.prototype.sha = function(string){
  return this._crypto.createHash('sha1').update(string).digest("hex");
}

Helpers.prototype.rnd = function(min, max){
	return this._random.integer(min, max);
}

Helpers.prototype.generateToken = function(length){
  var symbols = ['1','2','3','4','5','6','7','8','9','0','a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z'];
  var token = '';
  for(var i = 0; i < length; i++){
    token = token + symbols[this._random.integer(0, symbols.length-1)];
  }
  return token;
}

Helpers.prototype.stringifyNodes = function(object){
  for(var key in object){
    if(typeof object[key] != 'object'){
      object[key] = object[key].toString();
    }
  }
  return object;
}

Helpers.prototype.SteamIDtoPartnerID = function(steamid) {
    return steamid.substr(3) - 61197960265728;
}

Helpers.prototype.PartnerIDtoSteamID = function(partnerid) {
    return "765" + (Number(partnerid) + 61197960265728);
}

Helpers.prototype.BotToPort = function(bot){
  var result = '';
  var params = bot.split('_');
  if(params[0] == 'a') result += '3';
  if(params[0] == 'b') result += '4';
  for(var i = 0; i < 4 - params[1].toString().length; i++){
    result += "0";
  }
  result += params[1].toString();
  return result;
}

Helpers.prototype.TradelinkToSteamID = function(tradelink){
  var steamid = this.PartnerIDtoSteamID(tradelink.substr(51, tradelink.length - 66));
  return steamid;
}

Helpers.prototype.insertionSort = function(array){
  var len = array.length;
  for (var i = 0; i < len; i++) {
    var tmp = array[i].val;
    for (var j = i - 1; j >= 0 && (array[j].val > tmp); j--) {
      array[j + 1].val = array[j].val;
    }
    array[j + 1].val = tmp;
  }
  return array;
}

module.exports = Helpers;
