var YM = function(instance_id, to, success, fail, on_success){
  this.yandexMoney = require("yandex-money-sdk");

  this.IID = instance_id;
  this.to = to;
  this.success = success;
  this.fail = fail;
  this.on_success = on_success;
}

YM.prototype.requestNew = function(amount, message, callback){
  var externalPayment = new this.yandexMoney.ExternalPayment(this.IID);

  var options = {
      pattern_id : 'p2p',
      instance_id : this.IID,
      to : this.to,
      amount : amount,
      message : message
  };

  externalPayment.request(options, function requestComplete(err, data) {
    if(err) {
        callback(err, null);
        return;
    }

    if(data.status != 'success'){
      callback(data.error, null);
      return;
    }

    var requestId = data.request_id;

    var options = {
        request_id : requestId,
        ext_auth_success_uri : this.success + '/' + requestId + '/',
        ext_auth_fail_uri : this.fail + '/' + requestId + '/',
        request_token : true
    };

    externalPayment.process(options, function (err, data) {
        if(err) {
            callback(err, null);
            return;
        }

        if(data.status == 'refused'){
          callback(data.error, null);
          return;
        }

        callback(null, { rid : requestId, url : data.acs_uri, params : data.acs_params });
    });
  }.bind(this));
}

YM.prototype.processOld = function(request_id, socket_id){
  console.log('processing ' + request_id);

  var externalPayment = new this.yandexMoney.ExternalPayment(this.IID);

  var options = {
      request_id : request_id,
      ext_auth_success_uri : this.success + '/' + request_id + '/',
      ext_auth_fail_uri : this.fail + '/' + request_id + '/',
      request_token : true
  };

  externalPayment.process(options, function (err, data) {
      if(err) {
          console.log(err);
          return;
      }

      if(data.status == 'refused'){
        console.log(data.error);
        return;
      }

      if(data.status == 'in_progress'){
        console.log('retrying in ' + data.next_retry);
        setTimeout(function(){this.processOld(request_id, socket_id);}.bind(this), data.next_retry);
        return;
      }

      if(data.status == 'success'){
        console.log('success');
        console.log(data);
        this.on_success(request_id, data.invoice_id, data.money_source.pan_fragment, data.money_source.money_source_token, socket_id);
        return;
      }

  }.bind(this));
}

module.exports = YM;
